searchNodes=[{"doc":"Documentation for ExPlasma.","ref":"ExPlasma.html","title":"ExPlasma","type":"module"},{"doc":"Attempt to decode the given RLP list into a Transaction.If signed: false is given in the list of opts, expects the underlying RLP to not contain signatures.Only validates that the RLP is structurally correct and that the tx type is supported. Does not perform any other kind of validation, use validate/1 for that.Exampleiex&gt; rlp = &lt;&lt;248, 116, 1, 225, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...&gt; 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 237, 1, 235, 148, ...&gt; 29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, ...&gt; 55, 0, 110, 148, 46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, ...&gt; 206, 65, 226, 241, 55, 0, 110, 1, 128, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...&gt; 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; iex&gt; ExPlasma.decode(rlp, signed: false) {:ok, %ExPlasma.Transaction{ inputs: [ %ExPlasma.Output{ output_data: nil, output_id: %{blknum: 0, oindex: 0, position: 0, txindex: 0}, output_type: nil } ], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, outputs: [ %ExPlasma.Output{ output_data: %{ amount: 1, output_guard: &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, token: &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt; }, output_id: nil, output_type: 1 } ], witnesses: [], sigs: [], tx_data: 0, tx_type: 1 } }","ref":"ExPlasma.html#decode/2","title":"ExPlasma.decode/2","type":"function"},{"doc":"Encode the given Transaction into an RLP encodable list.If signed: false is given in the list of opts, will encode the transaction without its signatures.Exampleiex&gt; txn = ...&gt; %ExPlasma.Transaction{ ...&gt; inputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: nil, ...&gt; output_id: %{blknum: 0, oindex: 0, position: 0, txindex: 0}, ...&gt; output_type: nil ...&gt; } ...&gt; ], ...&gt; metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, ...&gt; outputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: %{ ...&gt; amount: 1, ...&gt; output_guard: &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, ...&gt; 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, ...&gt; token: &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, ...&gt; 65, 226, 241, 55, 0, 110&gt;&gt; ...&gt; }, ...&gt; output_id: nil, ...&gt; output_type: 1 ...&gt; } ...&gt; ], ...&gt; sigs: [], ...&gt; tx_data: 0, ...&gt; tx_type: 1 ...&gt; } iex&gt; ExPlasma.encode(txn, signed: false) {:ok, &lt;&lt;248, 116, 1, 225, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 237, 1, 235, 148, 29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110, 148, 46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110, 1, 128, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}","ref":"ExPlasma.html#encode/2","title":"ExPlasma.encode/2","type":"function"},{"doc":"Throwing version of encode/2","ref":"ExPlasma.html#encode!/2","title":"ExPlasma.encode!/2","type":"function"},{"doc":"Transaction fee claim V1Exampleiex&gt; ExPlasma.fee() 3","ref":"ExPlasma.html#fee/0","title":"ExPlasma.fee/0","type":"function"},{"doc":"Keccak hash the Transaction. This is used in the contracts and events to to reference transactions.Exampleiex&gt; rlp = &lt;&lt;248, 74, 192, 1, 193, 128, 239, 174, 237, 1, 235, 148, 29, 246, 47, 41, 27, ...&gt; 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110, 148, 46, ...&gt; 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, ...&gt; 0, 110, 1, 128, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...&gt; 0&gt;&gt; iex&gt; ExPlasma.hash(rlp) {:ok, &lt;&lt;87, 132, 239, 36, 144, 239, 129, 88, 63, 88, 116, 147, 164, 200, 113, 191, 124, 14, 55, 131, 119, 96, 112, 13, 28, 178, 251, 49, 16, 127, 58, 96&gt;&gt;}","ref":"ExPlasma.html#hash/1","title":"ExPlasma.hash/1","type":"function"},{"doc":"Simple payment type V1Exampleiex&gt; ExPlasma.payment_v1() 1","ref":"ExPlasma.html#payment_v1/0","title":"ExPlasma.payment_v1/0","type":"function"},{"doc":"Transaction typesExampleiex&gt; ExPlasma.transaction_types() [1, 3]","ref":"ExPlasma.html#transaction_types/0","title":"ExPlasma.transaction_types/0","type":"function"},{"doc":"Statelessly validate a transation.Returns :ok if valid or {:error, {atom, atom}} otherwise","ref":"ExPlasma.html#validate/1","title":"ExPlasma.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.html#t:transaction_type/0","title":"ExPlasma.transaction_type/0","type":"type"},{"doc":"Encapsulates the block data we receive from the contract. It returns two things:hash - The merkle root block hash of the plasma blocks.transactions - the list of Transactions associated with this given block","ref":"ExPlasma.Block.html","title":"ExPlasma.Block","type":"module"},{"doc":"Generate a new Block from a list of transactionsExampleiex&gt; %ExPlasma.Transaction{tx_type: 1} |&gt; List.wrap() |&gt; ExPlasma.Block.new() %ExPlasma.Block{ hash: &lt;&lt;168, 54, 172, 201, 1, 212, 18, 167, 34, 57, 232, 89, 151, 225, 172, 150, 208, 77, 194, 12, 174, 250, 146, 254, 93, 42, 28, 253, 203, 237, 247, 62&gt;&gt;, transactions: [ %ExPlasma.Transaction{ sigs: [], witnesses: [], inputs: [], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, outputs: [], tx_data: 0, tx_type: 1 } ] }","ref":"ExPlasma.Block.html#new/1","title":"ExPlasma.Block.new/1","type":"function"},{"doc":"","ref":"ExPlasma.Block.html#t:t/0","title":"ExPlasma.Block.t/0","type":"type"},{"doc":"Helper module to make crafting plasma transactions much simpler.","ref":"ExPlasma.Builder.html","title":"ExPlasma.Builder","type":"module"},{"doc":"Adds an input to the TransactionExampleiex&gt; ExPlasma.payment_v1() ...&gt; |&gt; new() ...&gt; |&gt; add_input(blknum: 1, txindex: 0, oindex: 0) ...&gt; |&gt; add_input(blknum: 2, txindex: 0, oindex: 0) %ExPlasma.Transaction{ tx_type: 1, inputs: [ %ExPlasma.Output{output_id: %{blknum: 1, txindex: 0, oindex: 0}}, %ExPlasma.Output{output_id: %{blknum: 2, txindex: 0, oindex: 0}}, ] }","ref":"ExPlasma.Builder.html#add_input/2","title":"ExPlasma.Builder.add_input/2","type":"function"},{"doc":"Adds an output to the TransactionExampleiex&gt; ExPlasma.payment_v1() ...&gt; |&gt; new() ...&gt; |&gt; add_output(output_type: 1, output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;, amount: 1}) ...&gt; |&gt; add_output(output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;, amount: 2) %ExPlasma.Transaction{ tx_type: 1, outputs: [ %ExPlasma.Output{output_type: 1, output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;, amount: 1}}, %ExPlasma.Output{output_type: 1, output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;, amount: 2}}, ] }","ref":"ExPlasma.Builder.html#add_output/2","title":"ExPlasma.Builder.add_output/2","type":"function"},{"doc":"Create a new TransactionExample# Empty payment v1 transaction iex&gt; new(ExPlasma.payment_v1()) %ExPlasma.Transaction{tx_type: 1, inputs: [], outputs: [], metadata: &lt;&lt;0::256&gt;&gt;} # New payment v1 transaction with metadata iex&gt; new(ExPlasma.payment_v1(), metadata: &lt;&lt;1::256&gt;&gt;) %ExPlasma.Transaction{tx_type: 1, inputs: [], outputs: [], metadata: &lt;&lt;1::256&gt;&gt;}","ref":"ExPlasma.Builder.html#new/2","title":"ExPlasma.Builder.new/2","type":"function"},{"doc":"Sign the inputs of the transaction with the given keys in the corresponding order.Returns a tuple {:ok, transaction} if success or {:error, atom} otherwise.Exampleiex&gt; key = &quot;0x79298b0292bbfa9b15705c56b6133201c62b798f102d7d096d31d7637f9b2382&quot; ...&gt; ExPlasma.payment_v1() ...&gt; |&gt; new() ...&gt; |&gt; sign([key]) {:ok, %ExPlasma.Transaction{ inputs: [], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, outputs: [], tx_data: 0, sigs: [ &lt;&lt;129, 213, 32, 15, 183, 218, 255, 22, 82, 95, 22, 86, 103, 227, 92, 109, 9, 89, 7, 142, 235, 107, 203, 29, 20, 231, 91, 168, 255, 119, 204, 239, 44, 125, 76, 109, 200, 196, 204, 230, 224, 241, 84, 75, 9, 3, 160, 177, 37, 181, 174, 98, 51, 15, 136, 235, 47, 96, 15, 209, 45, 85, 153, 2, 28&gt;&gt; ], tx_type: 1 }}","ref":"ExPlasma.Builder.html#sign/2","title":"ExPlasma.Builder.sign/2","type":"function"},{"doc":"","ref":"ExPlasma.Builder.html#sign!/2","title":"ExPlasma.Builder.sign!/2","type":"function"},{"doc":"Decorates the transaction with a nonce when given valid params for the type.Exampleiex&gt; tx = new(ExPlasma.fee()) iex&gt; with_nonce(tx, %{blknum: 1000, token: &lt;&lt;0::160&gt;&gt;}) {:ok, %ExPlasma.Transaction{ inputs: [], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, nonce: &lt;&lt;61, 119, 206, 68, 25, 203, 29, 23, 147, 224, 136, 32, 198, 128, 177, 74, 227, 250, 194, 173, 146, 182, 251, 152, 123, 172, 26, 83, 175, 194, 213, 238&gt;&gt;, outputs: [], sigs: [], tx_data: 0, tx_type: 3, witnesses: [] }}","ref":"ExPlasma.Builder.html#with_nonce/2","title":"ExPlasma.Builder.with_nonce/2","type":"function"},{"doc":"","ref":"ExPlasma.Builder.html#with_nonce!/2","title":"ExPlasma.Builder.with_nonce!/2","type":"function"},{"doc":"","ref":"ExPlasma.Builder.html#t:input_opts/0","title":"ExPlasma.Builder.input_opts/0","type":"type"},{"doc":"","ref":"ExPlasma.Builder.html#t:tx_opts/0","title":"ExPlasma.Builder.tx_opts/0","type":"type"},{"doc":"Provides access to applications configuration with additional validation.Application variables should be retrieved using this module instead of calling Application.get_env/3","ref":"ExPlasma.Configuration.html","title":"ExPlasma.Configuration","type":"module"},{"doc":"Retrieve the eip 712 domain from the config and validates its format. The expected format is: %{name: &quot;OMG Network&quot;, salt: &quot;0xfad5c7f626d80f9256ef01929f3beb96e058b8b4b0e3fe52d84f054c0e2a7a83&quot;, verifying_contract: &quot;0xd17e1233a03affb9092d5109179b43d6a8828607&quot;, version: &quot;1&quot;}Returns the domain if valid, or raise an exception otherwise.Exampleiex&gt; Application.put_env(:ex_plasma, :eip_712_domain, %{ ...&gt; name: &quot;OMG Network&quot;, ...&gt; salt: &quot;0xfad5c7f626d80f9256ef01929f3beb96e058b8b4b0e3fe52d84f054c0e2a7a83&quot;, ...&gt; verifying_contract: &quot;0xd17e1233a03affb9092d5109179b43d6a8828607&quot;, ...&gt; version: &quot;1&quot; ...&gt;}) iex&gt; ExPlasma.Configuration.eip_712_domain() %{ name: &quot;OMG Network&quot;, salt: &quot;0xfad5c7f626d80f9256ef01929f3beb96e058b8b4b0e3fe52d84f054c0e2a7a83&quot;, verifying_contract: &quot;0xd17e1233a03affb9092d5109179b43d6a8828607&quot;, version: &quot;1&quot; }","ref":"ExPlasma.Configuration.html#eip_712_domain/0","title":"ExPlasma.Configuration.eip_712_domain/0","type":"function"},{"doc":"Provides validation to application variables","ref":"ExPlasma.Configuration.Validator.html","title":"ExPlasma.Configuration.Validator","type":"module"},{"doc":"Validates the eip 712 domain format. The expected format is: %{name: &quot;OMG Network&quot;, salt: &quot;0xfad5c7f626d80f9256ef01929f3beb96e058b8b4b0e3fe52d84f054c0e2a7a83&quot;, verifying_contract: &quot;0xd17e1233a03affb9092d5109179b43d6a8828607&quot;, version: &quot;1&quot;}Returns the domain if valid, or raise an exception otherwise.Exampleiex&gt; ExPlasma.Configuration.Validator.validate_eip_712_domain(%{ ...&gt; name: &quot;OMG Network&quot;, ...&gt; salt: &quot;0xfad5c7f626d80f9256ef01929f3beb96e058b8b4b0e3fe52d84f054c0e2a7a83&quot;, ...&gt; verifying_contract: &quot;0xd17e1233a03affb9092d5109179b43d6a8828607&quot;, ...&gt; version: &quot;1&quot; ...&gt;}) %{ name: &quot;OMG Network&quot;, salt: &quot;0xfad5c7f626d80f9256ef01929f3beb96e058b8b4b0e3fe52d84f054c0e2a7a83&quot;, verifying_contract: &quot;0xd17e1233a03affb9092d5109179b43d6a8828607&quot;, version: &quot;1&quot; }","ref":"ExPlasma.Configuration.Validator.html#validate_eip_712_domain/1","title":"ExPlasma.Configuration.Validator.validate_eip_712_domain/1","type":"function"},{"doc":"","ref":"ExPlasma.Configuration.Validator.html#t:eip_712_domain_t/0","title":"ExPlasma.Configuration.Validator.eip_712_domain_t/0","type":"type"},{"doc":"Signs and validates signatures. Constructed signatures can be used directly in Ethereum with ecrecover call.","ref":"ExPlasma.Crypto.html","title":"ExPlasma.Crypto","type":"module"},{"doc":"Given public key, returns an address.","ref":"ExPlasma.Crypto.html#generate_address/1","title":"ExPlasma.Crypto.generate_address/1","type":"function"},{"doc":"Produces a KECCAK digest for the message.Exampleiex&gt; ExPlasma.Crypto.keccak_hash(&quot;omg!&quot;) &lt;&lt;241, 85, 204, 147, 187, 239, 139, 133, 69, 248, 239, 233, 219, 51, 189, 54, 171, 76, 106, 229, 69, 102, 203, 7, 21, 134, 230, 92, 23, 209, 187, 12&gt;&gt;","ref":"ExPlasma.Crypto.html#keccak_hash/1","title":"ExPlasma.Crypto.keccak_hash/1","type":"function"},{"doc":"Recovers the address of the signer from a binary-encoded signature.","ref":"ExPlasma.Crypto.html#recover_address/2","title":"ExPlasma.Crypto.recover_address/2","type":"function"},{"doc":"","ref":"ExPlasma.Crypto.html#t:address_t/0","title":"ExPlasma.Crypto.address_t/0","type":"type"},{"doc":"","ref":"ExPlasma.Crypto.html#t:hash_t/0","title":"ExPlasma.Crypto.hash_t/0","type":"type"},{"doc":"","ref":"ExPlasma.Crypto.html#t:pub_key_t/0","title":"ExPlasma.Crypto.pub_key_t/0","type":"type"},{"doc":"","ref":"ExPlasma.Crypto.html#t:recover_address_error/0","title":"ExPlasma.Crypto.recover_address_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Crypto.html#t:sig_t/0","title":"ExPlasma.Crypto.sig_t/0","type":"type"},{"doc":"Provides the common encoding functionality we use across all the transactions and clients.","ref":"ExPlasma.Encoding.html","title":"ExPlasma.Encoding","type":"module"},{"doc":"Converts a hex string into a binary.Examplesiex&gt; ExPlasma.Encoding.to_binary(&quot;0x1dF62f291b2E969fB0849d99D9Ce41e2F137006e&quot;) {:ok, &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;}","ref":"ExPlasma.Encoding.html#to_binary/1","title":"ExPlasma.Encoding.to_binary/1","type":"function"},{"doc":"Throwing version of to_binary/1Examplesiex&gt; ExPlasma.Encoding.to_binary!(&quot;0x1dF62f291b2E969fB0849d99D9Ce41e2F137006e&quot;) &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;","ref":"ExPlasma.Encoding.html#to_binary!/1","title":"ExPlasma.Encoding.to_binary!/1","type":"function"},{"doc":"Converts binary and integer values into its hex string equivalent.Examples# Convert a raw binary to hex iex&gt; raw = &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt; iex&gt; ExPlasma.Encoding.to_hex(raw) &quot;0x1df62f291b2e969fb0849d99d9ce41e2f137006e&quot; # Convert an integer to hex iex&gt; ExPlasma.Encoding.to_hex(1) &quot;0x1&quot;","ref":"ExPlasma.Encoding.html#to_hex/1","title":"ExPlasma.Encoding.to_hex/1","type":"function"},{"doc":"Converts a hex string into the integer value.Examples# Convert a hex string into an integer iex&gt; ExPlasma.Encoding.to_int(&quot;0xb&quot;) 11 # Convert a binary into an integer iex&gt; ExPlasma.Encoding.to_int(&lt;&lt;11&gt;&gt;) 11","ref":"ExPlasma.Encoding.html#to_int/1","title":"ExPlasma.Encoding.to_int/1","type":"function"},{"doc":"Represents an in-flight exit (IFE).","ref":"ExPlasma.InFlightExit.html","title":"ExPlasma.InFlightExit","type":"module"},{"doc":"Derive the in-flight exit ID from its transaction bytes.See https://github.com/omisego/plasma-contracts/blob/v1.0.3/plasma_framework/contracts/src/exits/utils/ExitId.sol#L53-L55","ref":"ExPlasma.InFlightExit.html#tx_bytes_to_id/1","title":"ExPlasma.InFlightExit.tx_bytes_to_id/1","type":"function"},{"doc":"Encapsulates all the interactions with the MerkleTree library.","ref":"ExPlasma.Merkle.html","title":"ExPlasma.Merkle","type":"module"},{"doc":"","ref":"ExPlasma.Merkle.html#proof/2","title":"ExPlasma.Merkle.proof/2","type":"function"},{"doc":"Generate a Merkle Root hash for the given list of transactions in encoded byte form.Examplesiex&gt; txns = %ExPlasma.Transaction{tx_type: 1} |&gt; ExPlasma.encode!(signed: false) |&gt; List.wrap() iex&gt; ExPlasma.Merkle.root_hash(txns) &lt;&lt;168, 54, 172, 201, 1, 212, 18, 167, 34, 57, 232, 89, 151, 225, 172, 150, 208, 77, 194, 12, 174, 250, 146, 254, 93, 42, 28, 253, 203, 237, 247, 62&gt;&gt;","ref":"ExPlasma.Merkle.html#root_hash/1","title":"ExPlasma.Merkle.root_hash/1","type":"function"},{"doc":"An Output.output_id - The identifier scheme for the Output. We currently have two: Position and Id. output_type - An integer value of what type of output data is associated. output_data - The main data for the output. This can be decode by the different output types.","ref":"ExPlasma.Output.html","title":"ExPlasma.Output","type":"behaviour"},{"doc":"Decode RLP data into an Output.Examples# Generate an Output from an RLP list iex&gt; encoded = &lt;&lt;245, 1, 243, 148, 205, 193, 229, 59, 220, 116, 187, 245, 181, 247, 21, 214, ...&gt; 50, 125, 202, 87, 133, 226, 40, 180, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...&gt; 0, 0, 0, 0, 0, 0, 0, 0, 136, 13, 224, 182, 179, 167, 100, 0, 0&gt;&gt; iex&gt; ExPlasma.Output.decode(encoded) {:ok, %ExPlasma.Output{ output_data: %{ amount: 1000000000000000000, output_guard: &lt;&lt;205, 193, 229, 59, 220, 116, 187, 245, 181, 247, 21, 214, 50, 125, 202, 87, 133, 226, 40, 180&gt;&gt;, token: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}, output_id: nil, output_type: 1 }}","ref":"ExPlasma.Output.html#decode/1","title":"ExPlasma.Output.decode/1","type":"function"},{"doc":"Throwing version of decode/1","ref":"ExPlasma.Output.html#decode!/1","title":"ExPlasma.Output.decode!/1","type":"function"},{"doc":"Decode RLP input position into an Output.Exampleiex&gt; encoded_position = &lt;&lt;59, 154, 202, 0&gt;&gt; iex&gt; ExPlasma.Output.decode_id(encoded_position) {:ok, %ExPlasma.Output{ output_data: nil, output_id: %{ blknum: 1, oindex: 0, position: 1000000000, txindex: 0 }, output_type: nil }}","ref":"ExPlasma.Output.html#decode_id/1","title":"ExPlasma.Output.decode_id/1","type":"function"},{"doc":"Throwing version of decode_id/1","ref":"ExPlasma.Output.html#decode_id!/1","title":"ExPlasma.Output.decode_id!/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.html#encode/1","title":"ExPlasma.Output.encode/1","type":"function"},{"doc":"Examples# Encode as an Output iex&gt; output = %ExPlasma.Output{ ...&gt; output_data: %{ ...&gt; amount: 1000000000000000000, ...&gt; output_guard: &lt;&lt;205, 193, 229, 59, 220, 116, 187, 245, 181, 247, 21, 214, 50, 125, 202, 87, 133, 226, 40, 180&gt;&gt;, ...&gt; token: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}, ...&gt; output_id: nil, ...&gt; output_type: 1 ...&gt; } iex&gt; ExPlasma.Output.encode(output) {:ok, &lt;&lt;245, 1, 243, 148, 205, 193, 229, 59, 220, 116, 187, 245, 181, 247, 21, 214, 50, 125, 202, 87, 133, 226, 40, 180, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 13, 224, 182, 179, 167, 100, 0, 0&gt;&gt;} # Encode as an Input iex&gt; output = %ExPlasma.Output{ ...&gt; output_data: nil, ...&gt; output_id: %{ ...&gt; blknum: 1, ...&gt; oindex: 0, ...&gt; position: 1000000000, ...&gt; txindex: 0 ...&gt; }, ...&gt; output_type: nil ...&gt; } iex&gt; ExPlasma.Output.encode(output, as: :input) {:ok, &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 154, 202, 0&gt;&gt;}","ref":"ExPlasma.Output.html#encode/2","title":"ExPlasma.Output.encode/2","type":"function"},{"doc":"Maps the given RLP list into an output.The RLP list must start with the output type and follow with its data.Only validates that the RLP is structurally correct. Does not perform any other kind of validation, use validate/1 for that.Examplesiex&gt; rlp = [ ...&gt; &lt;&lt;1&gt;&gt;, ...&gt; [ ...&gt; &lt;&lt;11, 246, 22, 41, 33, 46, 44, 159, 55, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, ...&gt; &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, ...&gt; &lt;&lt;1&gt;&gt; ...&gt; ] ...&gt;] iex&gt; ExPlasma.Output.to_map(rlp) {:ok, %ExPlasma.Output{ output_data: %{ amount: 1, output_guard: &lt;&lt;11, 246, 22, 41, 33, 46, 44, 159, 55, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, token: &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt; }, output_id: nil, output_type: 1} }","ref":"ExPlasma.Output.html#to_map/1","title":"ExPlasma.Output.to_map/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.html#c:to_map/1","title":"ExPlasma.Output.to_map/1","type":"callback"},{"doc":"Maps the given integer position into an output.Only validates that the RLP is structurally correct. Does not perform any other kind of validation, use validate/1 for that.Examplesiex&gt; pos = 1_000_000_000 iex&gt; ExPlasma.Output.to_map_id(pos) {:ok, %ExPlasma.Output{output_id: %{position: 1_000_000_000, blknum: 1, txindex: 0, oindex: 0}}}","ref":"ExPlasma.Output.html#to_map_id/1","title":"ExPlasma.Output.to_map_id/1","type":"function"},{"doc":"Encode an Output into RLP bytesExampleiex&gt; output = %ExPlasma.Output{ ...&gt; output_id: nil, ...&gt; output_type: 1, ...&gt; output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;, amount: 1} ...&gt; } iex&gt; ExPlasma.Output.to_rlp(output) {:ok, [&lt;&lt;1&gt;&gt;, [&lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1&gt;&gt;, &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, &lt;&lt;1&gt;&gt;]]}","ref":"ExPlasma.Output.html#to_rlp/1","title":"ExPlasma.Output.to_rlp/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.html#c:to_rlp/1","title":"ExPlasma.Output.to_rlp/1","type":"callback"},{"doc":"Transforms an Output identifer into an RLP encoded position. This is to generate the inputs in a Transaction.Exampleiex&gt; output = %ExPlasma.Output{ ...&gt; output_data: nil, ...&gt; output_id: %{ ...&gt; blknum: 1, ...&gt; oindex: 0, ...&gt; position: 1000000000, ...&gt; txindex: 0 ...&gt; }, ...&gt; output_type: nil ...&gt; } iex&gt; ExPlasma.Output.to_rlp_id(output) {:ok, &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 154, 202, 0&gt;&gt;}","ref":"ExPlasma.Output.html#to_rlp_id/1","title":"ExPlasma.Output.to_rlp_id/1","type":"function"},{"doc":"Validates the OutputExample# Validate a Payment v1 Output iex&gt; encoded = &lt;&lt;245, 1, 243, 148, 205, 193, 229, 59, 220, 116, 187, 245, 181, 247, 21, 214, ...&gt; 50, 125, 202, 87, 133, 226, 40, 180, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...&gt; 0, 0, 0, 0, 0, 0, 0, 0, 136, 13, 224, 182, 179, 167, 100, 0, 0&gt;&gt; iex&gt; encoded |&gt; ExPlasma.Output.decode!() |&gt; ExPlasma.Output.validate() :ok # Validate a Output position iex&gt; encoded_position = &lt;&lt;59, 154, 202, 0&gt;&gt; iex&gt; encoded_position |&gt; ExPlasma.Output.decode_id!() |&gt; ExPlasma.Output.validate() :ok","ref":"ExPlasma.Output.html#validate/1","title":"ExPlasma.Output.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.html#c:validate/1","title":"ExPlasma.Output.validate/1","type":"callback"},{"doc":"","ref":"ExPlasma.Output.html#t:decoding_error/0","title":"ExPlasma.Output.decoding_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:input_position/0","title":"ExPlasma.Output.input_position/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:mapping_error/0","title":"ExPlasma.Output.mapping_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:output/0","title":"ExPlasma.Output.output/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:output_data/0","title":"ExPlasma.Output.output_data/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:output_id/0","title":"ExPlasma.Output.output_id/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:output_type/0","title":"ExPlasma.Output.output_type/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:rlp/0","title":"ExPlasma.Output.rlp/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:t/0","title":"ExPlasma.Output.t/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:validation_errors/0","title":"ExPlasma.Output.validation_errors/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.html#t:validation_responses/0","title":"ExPlasma.Output.validation_responses/0","type":"type"},{"doc":"Generates an Output position if given the:blknum - The block number for this output txindex - The index of the Transaction in the block. oindex - The index of the Output in the Transaction.","ref":"ExPlasma.Output.Position.html","title":"ExPlasma.Output.Position","type":"module"},{"doc":"","ref":"ExPlasma.Output.Position.html#block_offset/0","title":"ExPlasma.Output.Position.block_offset/0","type":"function"},{"doc":"Decodes and returns the integer position.Exampleiex&gt; pos = &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 154, 202, 0&gt;&gt; iex&gt; ExPlasma.Output.Position.decode(pos) {:ok, 1_000_000_000}","ref":"ExPlasma.Output.Position.html#decode/1","title":"ExPlasma.Output.Position.decode/1","type":"function"},{"doc":"Encodes the output position into an RLP encodable object.Exampleiex&gt; pos = ExPlasma.Output.Position.pos(%{blknum: 1, txindex: 0, oindex: 0}) iex&gt; ExPlasma.Output.Position.encode(pos) &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 154, 202, 0&gt;&gt;","ref":"ExPlasma.Output.Position.html#encode/1","title":"ExPlasma.Output.Position.encode/1","type":"function"},{"doc":"Creates an output_id from a block number, a tx index and an output index.Exampleiex&gt; ExPlasma.Output.Position.new(1, 0, 0) %{blknum: 1, txindex: 0, oindex: 0, position: 1_000_000_000}","ref":"ExPlasma.Output.Position.html#new/3","title":"ExPlasma.Output.Position.new/3","type":"function"},{"doc":"Encodes the blknum, txindex, and oindex into a single integer.Exampleiex&gt; pos = %{blknum: 1, txindex: 0, oindex: 0} iex&gt; ExPlasma.Output.Position.pos(pos) 1_000_000_000","ref":"ExPlasma.Output.Position.html#pos/1","title":"ExPlasma.Output.Position.pos/1","type":"function"},{"doc":"Returns a map of the decoded position.Exampleiex&gt; pos = 1_000_000_000 iex&gt; ExPlasma.Output.Position.to_map(pos) {:ok, %{position: 1_000_000_000, blknum: 1, txindex: 0, oindex: 0}}","ref":"ExPlasma.Output.Position.html#to_map/1","title":"ExPlasma.Output.Position.to_map/1","type":"function"},{"doc":"Transforms the output position into a positive integer representing the position.Exampleiex&gt; output_id = %{blknum: 1, txindex: 0, oindex: 0} iex&gt; ExPlasma.Output.Position.to_rlp(output_id) &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 154, 202, 0&gt;&gt;","ref":"ExPlasma.Output.Position.html#to_rlp/1","title":"ExPlasma.Output.Position.to_rlp/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Position.html#transaction_offset/0","title":"ExPlasma.Output.Position.transaction_offset/0","type":"function"},{"doc":"Validates that values can give a valid position.Exampleiex&gt; output_id = %{blknum: 1, txindex: 0, oindex: 0} iex&gt; ExPlasma.Output.Position.validate(output_id) :ok","ref":"ExPlasma.Output.Position.html#validate/1","title":"ExPlasma.Output.Position.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Position.html#t:position/0","title":"ExPlasma.Output.Position.position/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Position.html#t:t/0","title":"ExPlasma.Output.Position.t/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Position.html#t:validation_responses/0","title":"ExPlasma.Output.Position.validation_responses/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Position.html#t:with_position/0","title":"ExPlasma.Output.Position.with_position/0","type":"type"},{"doc":"Contain stateless validation logic for position","ref":"ExPlasma.Output.Position.Validator.html","title":"ExPlasma.Output.Position.Validator","type":"module"},{"doc":"","ref":"ExPlasma.Output.Position.Validator.html#validate_blknum/1","title":"ExPlasma.Output.Position.Validator.validate_blknum/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Position.Validator.html#validate_oindex/1","title":"ExPlasma.Output.Position.Validator.validate_oindex/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Position.Validator.html#validate_txindex/1","title":"ExPlasma.Output.Position.Validator.validate_txindex/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Position.Validator.html#t:blknum_validation_errors/0","title":"ExPlasma.Output.Position.Validator.blknum_validation_errors/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Position.Validator.html#t:oindex_validation_errors/0","title":"ExPlasma.Output.Position.Validator.oindex_validation_errors/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Position.Validator.html#t:txindex_validation_errors/0","title":"ExPlasma.Output.Position.Validator.txindex_validation_errors/0","type":"type"},{"doc":"Abstract payment output type.","ref":"ExPlasma.Output.Type.AbstractPayment.html","title":"ExPlasma.Output.Type.AbstractPayment","type":"module"},{"doc":"Decode a map of the output data into the Abstract Payment formatOnly validates that the RLP is structurally correct. Does not perform any other kind of validation, use validate/1 for that.Exampleiex&gt; data = [&lt;&lt;1&gt;&gt;, [&lt;&lt;1::160&gt;&gt;, &lt;&lt;1::160&gt;&gt;, &lt;&lt;1&gt;&gt;]] iex&gt; ExPlasma.Output.Type.AbstractPayment.to_map(data) {:ok, %{ output_type: 1, output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;1::160&gt;&gt;, amount: 1} }}","ref":"ExPlasma.Output.Type.AbstractPayment.html#to_map/1","title":"ExPlasma.Output.Type.AbstractPayment.to_map/1","type":"function"},{"doc":"Encode a map of the output data into an RLP list.Exampleiex&gt; output = %{output_type: 1, output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;1::160&gt;&gt;, amount: 1}} iex&gt; ExPlasma.Output.Type.AbstractPayment.to_rlp(output) [&lt;&lt;1&gt;&gt;, [&lt;&lt;1::160&gt;&gt;, &lt;&lt;1::160&gt;&gt;, &lt;&lt;1&gt;&gt;]]","ref":"ExPlasma.Output.Type.AbstractPayment.html#to_rlp/1","title":"ExPlasma.Output.Type.AbstractPayment.to_rlp/1","type":"function"},{"doc":"Validates the output dataExampleiex&gt; data = %{output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;, amount: 1}} iex&gt; ExPlasma.Output.Type.AbstractPayment.validate(data) :ok","ref":"ExPlasma.Output.Type.AbstractPayment.html#validate/1","title":"ExPlasma.Output.Type.AbstractPayment.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:address/0","title":"ExPlasma.Output.Type.AbstractPayment.address/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:amount/0","title":"ExPlasma.Output.Type.AbstractPayment.amount/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:mapping_errors/0","title":"ExPlasma.Output.Type.AbstractPayment.mapping_errors/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:output_guard/0","title":"ExPlasma.Output.Type.AbstractPayment.output_guard/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:rlp/0","title":"ExPlasma.Output.Type.AbstractPayment.rlp/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:t/0","title":"ExPlasma.Output.Type.AbstractPayment.t/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:token/0","title":"ExPlasma.Output.Type.AbstractPayment.token/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:validation_error/0","title":"ExPlasma.Output.Type.AbstractPayment.validation_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.html#t:validation_responses/0","title":"ExPlasma.Output.Type.AbstractPayment.validation_responses/0","type":"type"},{"doc":"Contain stateless validation logic for abstract payment outputs","ref":"ExPlasma.Output.Type.AbstractPayment.Validator.html","title":"ExPlasma.Output.Type.AbstractPayment.Validator","type":"module"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.Validator.html#validate_amount/1","title":"ExPlasma.Output.Type.AbstractPayment.Validator.validate_amount/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.Validator.html#validate_output_guard/1","title":"ExPlasma.Output.Type.AbstractPayment.Validator.validate_output_guard/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.Validator.html#validate_token/1","title":"ExPlasma.Output.Type.AbstractPayment.Validator.validate_token/1","type":"function"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.Validator.html#t:amount_validation_errors/0","title":"ExPlasma.Output.Type.AbstractPayment.Validator.amount_validation_errors/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.Validator.html#t:output_guard_validation_errors/0","title":"ExPlasma.Output.Type.AbstractPayment.Validator.output_guard_validation_errors/0","type":"type"},{"doc":"","ref":"ExPlasma.Output.Type.AbstractPayment.Validator.html#t:token_validation_errors/0","title":"ExPlasma.Output.Type.AbstractPayment.Validator.token_validation_errors/0","type":"type"},{"doc":"An empty invalid output type. Used to return a default response if given an invalid output key.","ref":"ExPlasma.Output.Type.Empty.html","title":"ExPlasma.Output.Type.Empty","type":"module"},{"doc":"Fee Output Type.","ref":"ExPlasma.Output.Type.Fee.html","title":"ExPlasma.Output.Type.Fee","type":"module"},{"doc":"","ref":"ExPlasma.Output.Type.Fee.html#t:t/0","title":"ExPlasma.Output.Type.Fee.t/0","type":"type"},{"doc":"Payment V1 output type.","ref":"ExPlasma.Output.Type.PaymentV1.html","title":"ExPlasma.Output.Type.PaymentV1","type":"module"},{"doc":"","ref":"ExPlasma.Output.Type.PaymentV1.html#t:t/0","title":"ExPlasma.Output.Type.PaymentV1.t/0","type":"type"},{"doc":"Adapted from https://github.com/exthereum/blockchain. Defines helper functions for signing and getting the signature of a transaction, as defined in Appendix F of the Yellow Paper.For any of the following functions, if chain_id is specified, it's assumed that we're post-fork and we should follow the specification EIP-155 from:https://github.com/ethereum/EIPs/blob/master/EIPS/eip-155.md","ref":"ExPlasma.Signature.html","title":"ExPlasma.Signature","type":"module"},{"doc":"Recovers a public key from a signed hash.This implements Eq.(208) of the Yellow Paper, adapted from https://stackoverflow.com/a/20000007Exampleiex(1)&gt; ExPlasma.Signature.recover_public(&lt;&lt;2::256&gt;&gt;, &lt;&lt;168, 39, 110, 198, 11, 113, 141, 8, 168, 151, 22, 210, 198, 150, 24, 111, 23, ...(1)&gt; 173, 42, 122, 59, 152, 143, 224, 214, 70, 96, 204, 31, 173, 154, 198, 97, 94, ...(1)&gt; 203, 172, 169, 136, 182, 131, 11, 106, 54, 190, 96, 128, 227, 222, 248, 231, ...(1)&gt; 75, 254, 141, 233, 113, 49, 74, 28, 189, 73, 249, 32, 89, 165, 27&gt;&gt;) {:ok, &lt;&lt;233, 102, 200, 175, 51, 251, 139, 85, 204, 181, 94, 133, 233, 88, 251, 156, 123, 157, 146, 192, 53, 73, 125, 213, 245, 12, 143, 102, 54, 70, 126, 35, 34, 167, 2, 255, 248, 68, 210, 117, 183, 156, 4, 185, 77, 27, 53, 239, 10, 57, 140, 63, 81, 87, 133, 241, 241, 210, 250, 35, 76, 232, 2, 153&gt;&gt;}","ref":"ExPlasma.Signature.html#recover_public/3","title":"ExPlasma.Signature.recover_public/3","type":"function"},{"doc":"Recovers a public key from a signed hash.This implements Eq.(208) of the Yellow Paper, adapted from https://stackoverflow.com/a/20000007Exampleiex(1)&gt; ExPlasma.Signature.recover_public(&lt;&lt;2::256&gt;&gt;, ...(1)&gt; 28, ...(1)&gt; 38_938_543_279_057_362_855_969_661_240_129_897_219_713_373_336_787_331_739_561_340_553_100_525_404_231, ...(1)&gt; 23_772_455_091_703_794_797_226_342_343_520_955_590_158_385_983_376_086_035_257_995_824_653_222_457_926 ...(1)&gt; ) {:ok, &lt;&lt;121, 190, 102, 126, 249, 220, 187, 172, 85, 160, 98, 149, 206, 135, 11, 7, 2, 155, 252, 219, 45, 206, 40, 217, 89, 242, 129, 91, 22, 248, 23, 152, 72, 58, 218, 119, 38, 163, 196, 101, 93, 164, 251, 252, 14, 17, 8, 168, 253, 23, 180, 72, 166, 133, 84, 25, 156, 71, 208, 143, 251, 16, 212, 184&gt;&gt;}","ref":"ExPlasma.Signature.html#recover_public/5","title":"ExPlasma.Signature.recover_public/5","type":"function"},{"doc":"Produces a stand-alone, 65 bytes long, signature for message hash.","ref":"ExPlasma.Signature.html#signature_digest/2","title":"ExPlasma.Signature.signature_digest/2","type":"function"},{"doc":"","ref":"ExPlasma.Signature.html#t:hash_r/0","title":"ExPlasma.Signature.hash_r/0","type":"type"},{"doc":"","ref":"ExPlasma.Signature.html#t:hash_s/0","title":"ExPlasma.Signature.hash_s/0","type":"type"},{"doc":"","ref":"ExPlasma.Signature.html#t:hash_v/0","title":"ExPlasma.Signature.hash_v/0","type":"type"},{"doc":"","ref":"ExPlasma.Signature.html#t:keccak_hash/0","title":"ExPlasma.Signature.keccak_hash/0","type":"type"},{"doc":"","ref":"ExPlasma.Signature.html#t:public_key/0","title":"ExPlasma.Signature.public_key/0","type":"type"},{"doc":"","ref":"ExPlasma.Signature.html#t:signature_len/0","title":"ExPlasma.Signature.signature_len/0","type":"type"},{"doc":"Contains the base structure of transactions.","ref":"ExPlasma.Transaction.html","title":"ExPlasma.Transaction","type":"behaviour"},{"doc":"","ref":"ExPlasma.Transaction.html#c:build_nonce/1","title":"ExPlasma.Transaction.build_nonce/1","type":"callback"},{"doc":"Attempt to decode the given RLP list into a Transaction.If signed: false is given in the list of opts, expects the underlying RLP to not contain signatures.Only validates that the RLP is structurally correct and that the tx type is supported. Does not perform any other kind of validation, use validate/1 for that.Exampleiex&gt; rlp = &lt;&lt;248, 117, 192, 1, 225, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...&gt; 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 237, 1, 235, 148, 29, 246, ...&gt; 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, ...&gt; 110, 148, 46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, ...&gt; 226, 241, 55, 0, 110, 1, 128, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...&gt; 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; iex&gt; ExPlasma.Transaction.decode(rlp) {:ok, %ExPlasma.Transaction{ inputs: [ %ExPlasma.Output{ output_data: nil, output_id: %{blknum: 0, oindex: 0, position: 0, txindex: 0}, output_type: nil } ], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, outputs: [ %ExPlasma.Output{ output_data: %{ amount: 1, output_guard: &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, token: &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt; }, output_id: nil, output_type: 1 } ], witnesses: [], sigs: [], tx_data: 0, tx_type: 1 } }","ref":"ExPlasma.Transaction.html#decode/2","title":"ExPlasma.Transaction.decode/2","type":"function"},{"doc":"Encode the given Transaction into an RLP encodable list.If signed: false is given in the list of opts, will encode the transaction without its signatures.Exampleiex&gt; txn = ...&gt; %ExPlasma.Transaction{ ...&gt; inputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: nil, ...&gt; output_id: %{blknum: 0, oindex: 0, position: 0, txindex: 0}, ...&gt; output_type: nil ...&gt; } ...&gt; ], ...&gt; metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, ...&gt; outputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: %{ ...&gt; amount: 1, ...&gt; output_guard: &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, ...&gt; 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, ...&gt; token: &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, ...&gt; 65, 226, 241, 55, 0, 110&gt;&gt; ...&gt; }, ...&gt; output_id: nil, ...&gt; output_type: 1 ...&gt; } ...&gt; ], ...&gt; sigs: [], ...&gt; tx_data: 0, ...&gt; tx_type: 1 ...&gt; } iex&gt; ExPlasma.Transaction.encode(txn, signed: :false) {:ok, &lt;&lt;248, 116, 1, 225, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 237, 1, 235, 148, 29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110, 148, 46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110, 1, 128, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}","ref":"ExPlasma.Transaction.html#encode/2","title":"ExPlasma.Transaction.encode/2","type":"function"},{"doc":"Throwing version of encode/2","ref":"ExPlasma.Transaction.html#encode!/2","title":"ExPlasma.Transaction.encode!/2","type":"function"},{"doc":"Returns the hash of the transaction involved without the signatures","ref":"ExPlasma.Transaction.html#hash/1","title":"ExPlasma.Transaction.hash/1","type":"function"},{"doc":"Signs the inputs of the transaction with the given keys in the corresponding order. Only signs transactions that implement the ExPlasma.TypedData protocol.Returns{:ok, %Transaction{}} with sigs when succesfuly signed{:error, :not_signable} when the given transaction is not supported.Exampleiex&gt; key = &quot;0x79298b0292bbfa9b15705c56b6133201c62b798f102d7d096d31d7637f9b2382&quot; iex&gt; txn = %ExPlasma.Transaction{tx_type: 1} iex&gt; ExPlasma.Transaction.sign(txn, [key]) {:ok, %ExPlasma.Transaction{ sigs: [ &lt;&lt;129, 213, 32, 15, 183, 218, 255, 22, 82, 95, 22, 86, 103, 227, 92, 109, 9, 89, 7, 142, 235, 107, 203, 29, 20, 231, 91, 168, 255, 119, 204, 239, 44, 125, 76, 109, 200, 196, 204, 230, 224, 241, 84, 75, 9, 3, 160, 177, 37, 181, 174, 98, 51, 15, 136, 235, 47, 96, 15, 209, 45, 85, 153, 2, 28&gt;&gt; ], inputs: [], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, outputs: [], tx_type: 1, witnesses: [], tx_data: 0 }}","ref":"ExPlasma.Transaction.html#sign/2","title":"ExPlasma.Transaction.sign/2","type":"function"},{"doc":"Maps the given RLP list into a transaction.When the RLP list starts with a list, assumes it's the sigs and map it accordingly. If not starting with a list, assumes it's the transaction type.Only validates that the RLP is structurally correct. Does not perform any other kind of validation, use validate/1 for that.","ref":"ExPlasma.Transaction.html#to_map/1","title":"ExPlasma.Transaction.to_map/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.html#c:to_map/1","title":"ExPlasma.Transaction.to_map/1","type":"callback"},{"doc":"","ref":"ExPlasma.Transaction.html#c:to_rlp/1","title":"ExPlasma.Transaction.to_rlp/1","type":"callback"},{"doc":"Encode the given Transaction into an RLP encodable list.If signed: false is given in the list of opts, will not prepend the signatures to the RLP list.Exampleiex&gt; txn = ...&gt; %ExPlasma.Transaction{ ...&gt; inputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: nil, ...&gt; output_id: %{blknum: 0, oindex: 0, position: 0, txindex: 0}, ...&gt; output_type: nil ...&gt; } ...&gt; ], ...&gt; metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, ...&gt; outputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: %{ ...&gt; amount: 1, ...&gt; output_guard: &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, ...&gt; 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, ...&gt; token: &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, ...&gt; 65, 226, 241, 55, 0, 110&gt;&gt; ...&gt; }, ...&gt; output_id: nil, ...&gt; output_type: 1 ...&gt; } ...&gt; ], ...&gt; sigs: [], ...&gt; tx_data: &lt;&lt;0&gt;&gt;, ...&gt; tx_type: 1 ...&gt; } iex&gt; ExPlasma.Transaction.to_rlp(txn) {:ok, [ [], &lt;&lt;1&gt;&gt;, [&lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;], [ [ &lt;&lt;1&gt;&gt;, [ &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, &lt;&lt;1&gt;&gt; ] ] ], 0, &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; ]}","ref":"ExPlasma.Transaction.html#to_rlp/2","title":"ExPlasma.Transaction.to_rlp/2","type":"function"},{"doc":"Statelessly validate a transation.Exampleiex&gt; txn = %ExPlasma.Transaction{ ...&gt; inputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: nil, ...&gt; output_id: %{blknum: 0, oindex: 0, position: 0, txindex: 0}, ...&gt; output_type: nil ...&gt; } ...&gt; ], ...&gt; metadata: &lt;&lt;0::256&gt;&gt;, ...&gt; outputs: [ ...&gt; %ExPlasma.Output{ ...&gt; output_data: %{ ...&gt; amount: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 1&gt;&gt;, ...&gt; output_guard: &lt;&lt;29, 246, 47, 41, 27, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt;, ...&gt; token: &lt;&lt;46, 38, 45, 41, 28, 46, 150, 159, 176, 132, 157, 153, 217, 206, 65, 226, 241, 55, 0, 110&gt;&gt; ...&gt; }, ...&gt; output_id: nil, ...&gt; output_type: 1 ...&gt; } ...&gt; ], ...&gt; sigs: [], ...&gt; tx_data: 0, ...&gt; tx_type: 1 ...&gt;} iex&gt; :ok = ExPlasma.Transaction.validate(txn)","ref":"ExPlasma.Transaction.html#validate/1","title":"ExPlasma.Transaction.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.html#c:validate/1","title":"ExPlasma.Transaction.validate/1","type":"callback"},{"doc":"","ref":"ExPlasma.Transaction.html#with_nonce/2","title":"ExPlasma.Transaction.with_nonce/2","type":"function"},{"doc":"Recovers the witnesses as addresses and add them to the transaction struct under the witnesses key.","ref":"ExPlasma.Transaction.html#with_witnesses/1","title":"ExPlasma.Transaction.with_witnesses/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.html#t:decoding_error/0","title":"ExPlasma.Transaction.decoding_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:encoding_error/0","title":"ExPlasma.Transaction.encoding_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:mapping_error/0","title":"ExPlasma.Transaction.mapping_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:metadata/0","title":"ExPlasma.Transaction.metadata/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:nonce/0","title":"ExPlasma.Transaction.nonce/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:outputs/0","title":"ExPlasma.Transaction.outputs/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:t/0","title":"ExPlasma.Transaction.t/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:tx_bytes/0","title":"ExPlasma.Transaction.tx_bytes/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.html#t:tx_hash/0","title":"ExPlasma.Transaction.tx_hash/0","type":"type"},{"doc":"Holds functions related to transactions containing signatures.","ref":"ExPlasma.Transaction.Signed.html","title":"ExPlasma.Transaction.Signed","type":"module"},{"doc":"","ref":"ExPlasma.Transaction.Signed.html#compute_signatures/2","title":"ExPlasma.Transaction.Signed.compute_signatures/2","type":"function"},{"doc":"Decodes a binary expecting it to represent a signed transactions with the signatures being the first element of the decoded RLP list.Returns {:ok, signed_tx_rlp_items} if the encoded RLP can be decoded, or {:error, atom} otherwise.Only validates that the RLP is structurally correct. Does not perform any other kind of validation, use validate/1 for that.","ref":"ExPlasma.Transaction.Signed.html#decode/1","title":"ExPlasma.Transaction.Signed.decode/1","type":"function"},{"doc":"Recovers the witnesses for non-empty signatures, in the order they appear in transaction's signatures.Returns {:ok, witness_list} if witnesses are recoverable, or {:error, :corrupted_witness} otherwise.","ref":"ExPlasma.Transaction.Signed.html#get_witnesses/1","title":"ExPlasma.Transaction.Signed.get_witnesses/1","type":"function"},{"doc":"Validate a signed transaction.Returns :ok if valid or {:error, {:witnesses, :malformed_witnesses}} otherwise.","ref":"ExPlasma.Transaction.Signed.html#validate/1","title":"ExPlasma.Transaction.Signed.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Signed.html#t:decoding_error/0","title":"ExPlasma.Transaction.Signed.decoding_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Signed.html#t:sigs/0","title":"ExPlasma.Transaction.Signed.sigs/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Signed.html#t:tx_bytes/0","title":"ExPlasma.Transaction.Signed.tx_bytes/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Signed.html#t:validation_error/0","title":"ExPlasma.Transaction.Signed.validation_error/0","type":"type"},{"doc":"Implementation of Transaction behaviour for Fee claiming type.","ref":"ExPlasma.Transaction.Type.Fee.html","title":"ExPlasma.Transaction.Type.Fee","type":"module"},{"doc":"Creates output for a fee transactionExampleiex&gt; output = new_output(&lt;&lt;1::160&gt;&gt;, &lt;&lt;0::160&gt;&gt;, 1) iex&gt; %ExPlasma.Output{ ...&gt; output_data: %{amount: 1, output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;}, ...&gt; output_id: nil, ...&gt; output_type: 2 ...&gt; } = output","ref":"ExPlasma.Transaction.Type.Fee.html#new_output/3","title":"ExPlasma.Transaction.Type.Fee.new_output/3","type":"function"},{"doc":"Decodes an RLP list into a Fee Transaction.Only validates that the RLP is structurally correct. Does not perform any other kind of validation, use validate/1 for that.","ref":"ExPlasma.Transaction.Type.Fee.html#to_map/1","title":"ExPlasma.Transaction.Type.Fee.to_map/1","type":"function"},{"doc":"Turns a structure instance into a structure of RLP items, ready to be RLP encoded","ref":"ExPlasma.Transaction.Type.Fee.html#to_rlp/1","title":"ExPlasma.Transaction.Type.Fee.to_rlp/1","type":"function"},{"doc":"Validates the Transaction.","ref":"ExPlasma.Transaction.Type.Fee.html#validate/1","title":"ExPlasma.Transaction.Type.Fee.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.Fee.html#t:mapping_error/0","title":"ExPlasma.Transaction.Type.Fee.mapping_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Type.Fee.html#t:validation_error/0","title":"ExPlasma.Transaction.Type.Fee.validation_error/0","type":"type"},{"doc":"Contain stateless validation logic for Fee transactions","ref":"ExPlasma.Transaction.Type.Fee.Validator.html","title":"ExPlasma.Transaction.Type.Fee.Validator","type":"module"},{"doc":"","ref":"ExPlasma.Transaction.Type.Fee.Validator.html#validate_nonce/1","title":"ExPlasma.Transaction.Type.Fee.Validator.validate_nonce/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.Fee.Validator.html#validate_outputs/1","title":"ExPlasma.Transaction.Type.Fee.Validator.validate_outputs/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.Fee.Validator.html#t:outputs_validation_error/0","title":"ExPlasma.Transaction.Type.Fee.Validator.outputs_validation_error/0","type":"type"},{"doc":"Implementation of Transaction behaviour for Payment V1 type.","ref":"ExPlasma.Transaction.Type.PaymentV1.html","title":"ExPlasma.Transaction.Type.PaymentV1","type":"module"},{"doc":"Creates output for a payment v1 transactionExampleiex&gt; output = new_output(&lt;&lt;1::160&gt;&gt;, &lt;&lt;0::160&gt;&gt;, 1) iex&gt; %ExPlasma.Output{ ...&gt; output_data: %{amount: 1, output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;}, ...&gt; output_id: nil, ...&gt; output_type: 1 ...&gt; } = output","ref":"ExPlasma.Transaction.Type.PaymentV1.html#new_output/3","title":"ExPlasma.Transaction.Type.PaymentV1.new_output/3","type":"function"},{"doc":"Decodes an RLP list into a Payment V1 Transaction.Only validates that the RLP is structurally correct. Does not perform any other kind of validation, use validate/1 for that.","ref":"ExPlasma.Transaction.Type.PaymentV1.html#to_map/1","title":"ExPlasma.Transaction.Type.PaymentV1.to_map/1","type":"function"},{"doc":"Turns a structure instance into a structure of RLP items, ready to be RLP encoded","ref":"ExPlasma.Transaction.Type.PaymentV1.html#to_rlp/1","title":"ExPlasma.Transaction.Type.PaymentV1.to_rlp/1","type":"function"},{"doc":"Validates the Transaction.","ref":"ExPlasma.Transaction.Type.PaymentV1.html#validate/1","title":"ExPlasma.Transaction.Type.PaymentV1.validate/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.html#t:mapping_error/0","title":"ExPlasma.Transaction.Type.PaymentV1.mapping_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.html#t:metadata/0","title":"ExPlasma.Transaction.Type.PaymentV1.metadata/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.html#t:outputs/0","title":"ExPlasma.Transaction.Type.PaymentV1.outputs/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.html#t:validation_error/0","title":"ExPlasma.Transaction.Type.PaymentV1.validation_error/0","type":"type"},{"doc":"Contain stateless validation logic for Payment V1 transactions","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html","title":"ExPlasma.Transaction.Type.PaymentV1.Validator","type":"module"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html#is_metadata/1","title":"ExPlasma.Transaction.Type.PaymentV1.Validator.is_metadata/1","type":"macro"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html#validate_inputs/1","title":"ExPlasma.Transaction.Type.PaymentV1.Validator.validate_inputs/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html#validate_metadata/1","title":"ExPlasma.Transaction.Type.PaymentV1.Validator.validate_metadata/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html#validate_outputs/1","title":"ExPlasma.Transaction.Type.PaymentV1.Validator.validate_outputs/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html#validate_tx_data/1","title":"ExPlasma.Transaction.Type.PaymentV1.Validator.validate_tx_data/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html#t:inputs_validation_error/0","title":"ExPlasma.Transaction.Type.PaymentV1.Validator.inputs_validation_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Type.PaymentV1.Validator.html#t:outputs_validation_error/0","title":"ExPlasma.Transaction.Type.PaymentV1.Validator.outputs_validation_error/0","type":"type"},{"doc":"Provides wire format's tx/output type values and mapping to modules which decodes them.","ref":"ExPlasma.Transaction.TypeMapper.html","title":"ExPlasma.Transaction.TypeMapper","type":"module"},{"doc":"Returns wire format type value of known output type","ref":"ExPlasma.Transaction.TypeMapper.html#output_type_for/1","title":"ExPlasma.Transaction.TypeMapper.output_type_for/1","type":"function"},{"doc":"Returns module atom that is able to decode output of given type","ref":"ExPlasma.Transaction.TypeMapper.html#output_type_modules/0","title":"ExPlasma.Transaction.TypeMapper.output_type_modules/0","type":"function"},{"doc":"Returns wire format type value of known transaction type","ref":"ExPlasma.Transaction.TypeMapper.html#tx_type_for/1","title":"ExPlasma.Transaction.TypeMapper.tx_type_for/1","type":"function"},{"doc":"Returns module atom that is able to decode transaction of given type","ref":"ExPlasma.Transaction.TypeMapper.html#tx_type_modules/0","title":"ExPlasma.Transaction.TypeMapper.tx_type_modules/0","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.TypeMapper.html#t:tx_type_to_output_module_map/0","title":"ExPlasma.Transaction.TypeMapper.tx_type_to_output_module_map/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.TypeMapper.html#t:tx_type_to_tx_module_map/0","title":"ExPlasma.Transaction.TypeMapper.tx_type_to_tx_module_map/0","type":"type"},{"doc":"Code required to validate and recover raw witnesses (e.g. signatures) goes here.","ref":"ExPlasma.Transaction.Witness.html","title":"ExPlasma.Transaction.Witness","type":"module"},{"doc":"Prepares the witness to be quickly used in stateful validation","ref":"ExPlasma.Transaction.Witness.html#recover/2","title":"ExPlasma.Transaction.Witness.recover/2","type":"function"},{"doc":"Pre-check done after decoding to quickly assert whether the witness has one of valid forms","ref":"ExPlasma.Transaction.Witness.html#valid?/1","title":"ExPlasma.Transaction.Witness.valid?/1","type":"function"},{"doc":"","ref":"ExPlasma.Transaction.Witness.html#t:recovery_error/0","title":"ExPlasma.Transaction.Witness.recovery_error/0","type":"type"},{"doc":"","ref":"ExPlasma.Transaction.Witness.html#t:t/0","title":"ExPlasma.Transaction.Witness.t/0","type":"type"},{"doc":"EIP 712 signing encoding","ref":"ExPlasma.TypedData.html","title":"ExPlasma.TypedData","type":"protocol"},{"doc":"The EIP712 encoded type data structure.","ref":"ExPlasma.TypedData.html#encode/2","title":"ExPlasma.TypedData.encode/2","type":"function"},{"doc":"The keccak hash of the encoded data type.","ref":"ExPlasma.TypedData.html#hash/2","title":"ExPlasma.TypedData.hash/2","type":"function"},{"doc":"","ref":"ExPlasma.TypedData.html#t:t/0","title":"ExPlasma.TypedData.t/0","type":"type"},{"doc":"Provides functions to decode various data types from RLP raw format","ref":"ExPlasma.Utils.RlpDecoder.html","title":"ExPlasma.Utils.RlpDecoder","type":"module"},{"doc":"Attempt to decode the given binary to a list of RLP items","ref":"ExPlasma.Utils.RlpDecoder.html#decode/1","title":"ExPlasma.Utils.RlpDecoder.decode/1","type":"function"},{"doc":"Parses 20-bytes address Case &lt;&lt;&gt;&gt; is necessary, because RLP handles empty string equally to integer 0","ref":"ExPlasma.Utils.RlpDecoder.html#parse_address/1","title":"ExPlasma.Utils.RlpDecoder.parse_address/1","type":"function"},{"doc":"Parses unsigned at-most 32-bytes integer. Leading zeros are disallowed","ref":"ExPlasma.Utils.RlpDecoder.html#parse_uint256/1","title":"ExPlasma.Utils.RlpDecoder.parse_uint256/1","type":"function"},{"doc":"Parses unsigned at-most 32-bytes integer. Leading zeros are allowed","ref":"ExPlasma.Utils.RlpDecoder.html#parse_uint256_with_leading/1","title":"ExPlasma.Utils.RlpDecoder.parse_uint256_with_leading/1","type":"function"},{"doc":"","ref":"ExPlasma.Utils.RlpDecoder.html#t:parse_uint256_errors/0","title":"ExPlasma.Utils.RlpDecoder.parse_uint256_errors/0","type":"type"},{"doc":"","ref":"readme.html","title":"README","type":"extras"},{"doc":"ExPlasma is an Elixir library for encoding, decoding and validating transactions used for the OMG Network Plasma contracts.","ref":"readme.html#explasma","title":"README - ExPlasma","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding ex_plasma to your list of dependencies in mix.exs:def deps do [ {:ex_plasma, &quot;~&gt; 0.2.0&quot;} ] endYou will also need to specify some configurations in your config/config.exs:config :ex_plasma, eip_712_domain: %{ name: &quot;OMG Network&quot;, salt: &quot;0xfad5c7f626d80f9256ef01929f3beb96e058b8b4b0e3fe52d84f054c0e2a7a83&quot;, verifying_contract: &quot;0xd17e1233a03affb9092d5109179b43d6a8828607&quot;, version: &quot;1&quot; }","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"ExPlasma requires Rust to be installed because it uses Rust NIFs for keccak hash and secp256k1.Clone the repo to your desktop git@github.com:omgnetwork/ex_plasma.gitRun mix compile in your terminal.If there are any unavailable dependencies, run mix deps.get.","ref":"readme.html#setup","title":"README - Setup","type":"extras"},{"doc":"To build a transaction use ExPlasma.Builder module:{:ok, txn} = ExPlasma.payment_v1() |&gt; ExPlasma.Builder.new() |&gt; ExPlasma.Builder.add_input(blknum: 1, txindex: 0, oindex: 0) |&gt; ExPlasma.Builder.add_output(output_type: 1, output_data: %{output_guard: &lt;&lt;1::160&gt;&gt;, token: &lt;&lt;0::160&gt;&gt;, amount: 1}) |&gt; ExPlasma.Builder.sign([&quot;0x79298b0292bbfa9b15705c56b6133201c62b798f102d7d096d31d7637f9b2382&quot;]) {:ok, %ExPlasma.Transaction{ inputs: [ %ExPlasma.Output{ output_data: nil, output_id: %{blknum: 1, oindex: 0, txindex: 0}, output_type: nil } ], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, nonce: nil, outputs: [ %ExPlasma.Output{ output_data: %{ amount: 1, output_guard: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1&gt;&gt;, token: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; }, output_id: nil, output_type: 1 } ], sigs: [ &lt;&lt;236, 177, 165, 5, 109, 208, 210, 116, 68, 176, 199, 17, 168, 29, 30, 198, 77, 45, 233, 147, 149, 38, 93, 136, 24, 98, 53, 218, 52, 177, 200, 127, 26, 6, 138, 17, 36, 52, 97, 152, 240, 222, ...&gt;&gt; ], tx_data: 0, tx_type: 1, witnesses: [] }}You can encode a transaction using ExPlasma.encode/2:{:ok, rlp} = ExPlasma.encode(txn, signed: false) {:ok, &lt;&lt;248, 116, 1, 225, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 154, 202, 0, 238, 237, 1, 235, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 128, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}You can decode a transaction using ExPlasma.decode/2:{:ok, txn} = ExPlasma.decode(rlp, signed: false) {:ok, %ExPlasma.Transaction{ inputs: [ %ExPlasma.Output{ output_data: nil, output_id: %{blknum: 1, oindex: 0, position: 1000000000, txindex: 0}, output_type: nil } ], metadata: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, nonce: nil, outputs: [ %ExPlasma.Output{ output_data: %{ amount: 1, output_guard: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1&gt;&gt;, token: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; }, output_id: nil, output_type: 1 } ], sigs: [], tx_data: 0, tx_type: 1, witnesses: [] }}You can validate a transaction using ExPlasma.validate/1:ExPlasma.validate(txn)View the documentation","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"You can run the tests by running;mix test mix credo mix dialyzerThis will load up Ganche and the plasma contracts to deploy.Conformance testTo ensure we can encode/decode according to the contracts, we have a separate suite of conformance tests that loads up mock contracts to compare encoding results. You can run the test by:make up-mocks mix test --only conformanceThis will spin up ganache and deploy the mock contracts.","ref":"readme.html#testing","title":"README - Testing","type":"extras"},{"doc":"Fork it!Create your feature branch (git checkout -b my-new-feature)Commit your changes (git commit -am 'Add some feature')Push to the branch (git push origin my-new-feature)Create new Pull Request","ref":"readme.html#contributing","title":"README - Contributing","type":"extras"},{"doc":"ExPlasma is released under the Apache-2.0 License.","ref":"readme.html#license","title":"README - License","type":"extras"}]